proc kue {x1_ y1_ x2_ y2_ lges_a is1 is2 ivorz} {

    upvar $x1_ x1
    upvar $y1_ y1
    upvar $x2_ x2
    upvar $y2_ y2

    set eps 0.0000000001

    set kvertauscht 0
    set ianz 1

    erm_weg $lges_a x1 y1 weg_a

    set is1 [expr $is1+$lges_a*$ianz-$ianz]
    set is2 [expr $is2+$lges_a*$ianz-$ianz]

    #do i=1,ianz*2
    for {set i 1} {$i <= [expr $ianz*2]} {incr i} {
        #do j=1,lges_a
        for {set j 1} {$j <= $lges_a} {incr j} {
            set weg_a([expr $j+$i*($lges_a-1)]) [expr $weg_a($j)+double($i)*$weg_a($lges_a)]
            set x1([expr $j+$i*($lges_a-1)]) $x1($j)
            set y1([expr $j+$i*($lges_a-1)]) $y1($j)
            set x2([expr $j+$i*($lges_a-1)]) $x2($j)
            set y2([expr $j+$i*($lges_a-1)]) $y2($j)
        }
    }

    set lges_a_ur $lges_a
    set lges_a [expr (2*$ianz+1)*($lges_a-1)+1]

    set weg_a($lges_a) [expr double($ianz+2)*$weg_a($lges_a_ur)]
    set x1($lges_a) $x1($lges_a_ur)
    set y1($lges_a) $y1($lges_a_ur)
    set x2($lges_a) $x2($lges_a_ur)
    set y2($lges_a) $y2($lges_a_ur)

    cubicp  $lges_a weg_a x1 ya2
    koeff $lges_a weg_a x1 ya2 ax1 bx1 cx1 dx1
    cubicp  $lges_a weg_a y1 ya2
    koeff $lges_a weg_a y1 ya2 ay1 by1 cy1 dy1
    cubicp  $lges_a weg_a x2 ya2
    koeff $lges_a weg_a x2 ya2 ax2 bx2 cx2 dx2
    cubicp  $lges_a weg_a y2 ya2
    koeff $lges_a weg_a y2 ya2 ay2 by2 cy2 dy2




    set weg_step [expr ($weg_a($lges_a_ur)-$weg_a(1))/($lges_a_ur-1)*$ivorz]
    set weg_step_ur $weg_step

    set jstop 0
    while {$jstop < 2} {
        set weg_is3 0.0
        set weg_is1 $weg_a($is1)
        set weg_is2 $weg_a($is2)
        set weg_step2 0
        set jerr 0
        #while {$jerr == 0 && $lges_k < $lges_a_ur}
        while {$jerr == 0 } {
            puts ok1
            set jerr [kue_solver $weg_is1 $weg_is2 $weg_is3 $weg_step $weg_step2 \
                       $eps $lges_a_ur weg_a $lges_a \
                       x1 ax1 bx1 cx1 dx1 y1 ay1 by1 cy1 dy1 \
                       x2 ax2 bx2 cx2 dx2 y2 ay2 by2 cy2 dy2]
#            if (jerr.lt.30) then
#                call neue_startwerte(weg_step_ur,weg_is1,weg_is2,
# +                  weg_step,weg_step2,weg_is3,jerr)
#            end if
        }
#
#        if (jerr.ne.0) lges_k=lges_k-1
#        call speicher_werte(*1,xdp,ydp,xg1,yg1,xg2,yg2,
# +          x1p1,y1p1,x1p2,y1p2,x2p1,y2p1,x2p2,y2p2,i_viergl,2,
# +          w_loes1,w_loes2,weg_a,lges_a,lges_a_ur)
#
#        if (jstop.eq.0) then
#            kk=1000
#            string='Nein'
#            call read_a(
# +              'entgegengesetzte Suchrichtung probieren',*1,
# +              string,iw,rw,kk,icorr,0,'1g,Ja,Nein',1.,nv+0.)
#            if (string(:1).eq.'J') then
#                weg_step=(weg_a(lges_a_ur)-weg_a(1))/(lges_a_ur-1)
#                weg_step=-weg_step*ivorz
#                call umspeichern(*1,y_2,nma,lges_k)
#                jstop=1
#            else
#                jstop=2
#            end if
#        else
            set jstop 2
#        end if
    }
}
############################################################################
# Ermitteln eines geschlossen zu Ermittelnden Teils der Uebergangskurve

proc kue_solver {weg_is1 weg_is2 weg_is3 weg_step weg_step2 eps lges_a_ur \
                weg_a_ lges_a x1_ ax1_ bx1_ cx1_ dx1_ y1_ ay1_ by1_ cy1_ dy1_ \
                       x2_ ax2_ bx2_ cx2_ dx2_ y2_ ay2_ by2_ cy2_ dy2_} {

     #   subroutine kue_solver(*,weg_is1,weg_is2,weg_is3,weg_step,
     #+          weg_step2,eps,lges_a_ur,iberech_abl, jerr)

# geg.: weg_is1,weg_is2,weg_is3,weg_step,eps,lges_a_ur,iberech_abl
# ges.: jerr

# weg_is1 : Startposition von weg_a() fr Lage 1
# weg_is2 : Startposition von weg_a() fr Lage 2
# weg_is3 : weg_is3=0 --> mit weg_is1 und weg_is2 Startlsung suchen
#           weg_is3<>0 -> Startlsung zwischen weg_is2 und weg_is3
# weg_step: Schrittweite fr Stellung 1 (positiv oder negativ)
# weg_step2:Schrittweite fr Stellung 2 (positiv oder negativ)
# eps     : Genauigkeitsschranke
# lges_a_ur:Anzahl eingelesener Sttzstellen
# iberech_abl: Kennzahl
#         iberech_abl=0 --> Ableitung fr Newton  wird nicht berechnet
#                           ('****ss' mu nicht gegeben sein!)
#         iberech_abl=1 --> Ableitung fr Newton  wird berechnet
# jerr    : Kennzahl
#           jerr=1 --> Schrittweite hat Minimum unterschritten
#           jerr=2 --> Es wurde keine Startlsung fr REGULA FALSI
#                      gefunden
#           jerr=3 --> Es wurde keine Lsung mit REGULA FALSI gefunden
#....................................................................
#....................................................................

    upvar $weg_a_ weg_a
    upvar $x1_ x1
    upvar $ax1_ ax1
    upvar $bx1_ bx1
    upvar $cx1_ cx1
    upvar $dx1_ dx1
    upvar $y1_ y1
    upvar $ay1_ ay1
    upvar $by1_ by1
    upvar $cy1_ cy1
    upvar $dy1_ dy1
    upvar $x2_ x2
    upvar $ax2_ ax2
    upvar $bx2_ bx2
    upvar $cx2_ cx2
    upvar $dx2_ dx2
    upvar $y2_ y2
    upvar $ay2_ ay2
    upvar $by2_ by2
    upvar $cy2_ cy2
    upvar $dy2_ dy2

    # aendern!
    set weg_step2 0

    set jerr 0
    set jstop 0
    set weg_step_old $weg_step
    set weg_1 [expr $weg_is1-$weg_step]
    set w_loes2 $weg_is2
    set w_loes2_alt $weg_is2
    set weg_2 $weg_is2
    set ido 0

    set izaehl 0
    set i_wiederhol 0

    puts ok2

    while {$weg_1 < $weg_a($lges_a) && $weg_1 > 0.0 && $weg_2 < $weg_a($lges_a) \
    && $weg_2 > 0.0 && $jstop == 0} {
        incr izaehl
        set weg_1 [expr $weg_1+$weg_step]
        set weg_2 $w_loes2
        if {$ido > 0} then {
            if {[expr abs([expr $w_loes2-$w_loes2_alt])] > \
            [expr abs([expr 2.0*$weg_step_old])]} then {
#       Schrittweite verkleinern, da 2 Getriebelage zu stark variiert
                if {abs([expr $weg_step/2.0]) > abs([$weg_step_old/7.0])} then {
                    set weg_step [expr $weg_step/2.0]
                    set weg_2 [expr $w_loes2_alt+($w_loes2-$w_loes2_alt)/2.0]
#                       write(ou,'(1x,a,f9.7,a)')
#     +                     'Schrittweite wird verkleinert auf ',
#    +                      weg_step,' m'
#                    write(ou,'(''<'',$)')
                } else {
                    set jstop 1
                    # Schrittweite wird zu klein
                    set jerr 1
                    break
                }
            } elseif {[expr abs([expr $w_loes2-$w_loes2_alt])] < \
            [expr abs([expr 0.5*$weg_step_old])]} then {
#       Schrittweite vergroessern, da 2 Getriebelage zu wenig variiert
                if {abs($weg_step) < abs($weg_step_old)} then {
                    set weg_step [expr $weg_step*2.0]
                    set weg_2 [expr $w_loes2_alt+($w_loes2-$w_loes2_alt)*2.0]
#                   write(ou,'(1x,a,f9.7,a)')
#    +                 'Schrittweite wird vergrert auf ',weg_step,' m'
#                    write(ou,'(''>'',$)')
                }
            }
# Vorhersagen, wo neue 2. Getriebelage wahrscheinlich liegen wird
            set weg_2 [expr $weg_2+($weg_2-$w_loes2_alt)]
        } else {
            set weg_2 [expr $weg_2+$weg_step2]
        }

        set i_spl 1
        set ierr [setz_lage1 $weg_1 $i_spl \
                weg_a x1 ax1 bx1 cx1 dx1 y1 ay1 by1 cy1 dy1 \
                       x2 ax2 bx2 cx2 dx2 y2 ay2 by2 cy2 dy2 $lges_a]

        puts ok3
        if {$ierr == 0} then {
            set w_loes1 $weg_1
            set weg_rf1 $weg_is2
        } else {
            tk_messageBox -type ok -message "Probleme mit Splines"
        }
        if {$ierr != 0} then {
        # Es wurde keine Startloesung fuer REGULA FALSI gefunden
            set jerr 2
            set jstop 1
        } else {
            set w_loes2_alt $w_loes2
            puts ok4
            set ierr [loes_newton $weg_2 $eps w_loes2 fx \
                         weg_a $lges_a x1 ax1 bx1 cx1 dx1 y1 ay1 by1 cy1 dy1 \
                         x2 ax2 bx2 cx2 dx2 y2 ay2 by2 cy2 dy2]
            puts ok5

            if {$ierr != 0} then {
                tk_messageBox -type ok -message "Es wurde keine Lsung gefunden"
                set jerr 3
                set jstop 1
            } else {
                set ifehler 0
#                call speicher_werte(*1,xdp,ydp,xg1,yg1,xg2,yg2,
# +                  x1p1,y1p1,x1p2,y1p2,x2p1,y2p1,x2p2,y2p2,
# +                  i_viergl,0,w_loes1,w_loes2,weg_a,lges_a,
# +                  lges_a_ur)
                if {$ierr ==0} then {
#       Pruefen, ob Ergebnis zu vorherigen Ergebnissen passt
                    set ierr [pruef_ergebnis $weg_step_old [expr $weg_a($lges_a)/$lges_a]]
                    if {$ierr != 0} then {
                        if {$ierr == 1 && $i_wiederhol == 0} then {
#       Ergebnis weist Sprung auf
                            set weg_step [expr $weg_step/2.]
                            set jerr 0
                            set i_wiederhol 1
                            incr ido
                            continue
                        } else {
                            set jerr 30
                            set jstop 1
                        }
                    }
                }

            }
        }
        set i_wiederhol 0
        incr ido
    }


    return $jerr
}
###############################################################################
# Naeherungsverfahren nach Newton

proc loes_newton {x_alt_ur eps x_ fx_ \
                  weg_a_ lges_a x1_ ax1_ bx1_ cx1_ dx1_ y1_ ay1_ by1_ cy1_ dy1_ \
                  x2_ ax2_ bx2_ cx2_ dx2_ y2_ ay2_ by2_ cy2_ dy2_} {

# geg.: x_alt_ur,eps
# ges.: x,fx,ierr

# x_alt_ur: x-Wert
# eps   : ist abs(f(x))<eps, so wird Iteration beendet
# x     : x-Wert der Loesung
# fx    : Wert von f(x)
# ierr  : Kennzahl
#         ierr=0 --> Es wurde eine Loesung gefunden
#         ierr=1 --> Es trat ein Fehler beim Loesen auf
#.............................................................
#.............................................................
    upvar $x_ x
    upvar $fx_ fx

    upvar $weg_a_ weg_a
    upvar $x1_ x1
    upvar $ax1_ ax1
    upvar $bx1_ bx1
    upvar $cx1_ cx1
    upvar $dx1_ dx1
    upvar $y1_ y1
    upvar $ay1_ ay1
    upvar $by1_ by1
    upvar $cy1_ cy1
    upvar $dy1_ dy1
    upvar $x2_ x2
    upvar $ax2_ ax2
    upvar $bx2_ bx2
    upvar $cx2_ cx2
    upvar $dx2_ dx2
    upvar $y2_ y2
    upvar $ay2_ ay2
    upvar $by2_ by2
    upvar $cy2_ cy2
    upvar $dy2_ dy2

    global i_ges_ i_anz_

    if {[info exists i_ges_] == 0} then {
        set i_ges_ 0
    }
    if {[info exists i_anz_] == 0} then {
        set i_anz_ 0
    }

    set ierr 0

    set x_alt $x_alt_ur
    puts ok6
    set fx [ywert8_rf2 $x_alt $eps fxs ierr \
            weg_a $lges_a x1 ax1 bx1 cx1 dx1 y1 ay1 by1 cy1 dy1 \
            x2 ax2 bx2 cx2 dx2 y2 ay2 by2 cy2 dy2]
    puts ok7
    set i 0
    while {$ierr == 0 && [expr abs($fx)] > $eps && $i <= 10000} {
        incr i
        set x [expr $x_alt-$fx/$fxs]
        set fx [ywert8_rf2 $x $eps fxs ierr \
                weg_a $lges_a x1 ax1 bx1 cx1 dx1 y1 ay1 by1 cy1 dy1 \
                x2 ax2 bx2 cx2 dx2 y2 ay2 by2 cy2 dy2]
        if {$ierr != 0} then {
            set x [expr $x+($x_alt-$x)/2.]
            set fx [ywert8_rf2 $x $eps fxs ierr \
                    weg_a $lges_a x1 ax1 bx1 cx1 dx1 y1 ay1 by1 cy1 dy1 \
                    x2 ax2 bx2 cx2 dx2 y2 ay2 by2 cy2 dy2]
            if {$ierr != 0} then {
                set x [expr $x-($x_alt-$x)]
                set fx [ywert8_rf2 $x $eps fxs ierr \
                        weg_a $lges_a x1 ax1 bx1 cx1 dx1 y1 ay1 by1 cy1 dy1 \
                        x2 ax2 bx2 cx2 dx2 y2 ay2 by2 cy2 dy2]
            }
        }
        x_alt=x
    }
    if {$i >= 10000} then {
        tk_messageBox -type ok -message "i_anz_=$i_anz_,i_ges_=$i_ges_,fx=$fx"
        if {[expr $fx*$fx] >= $eps} then {
            set ierr 1
        }
    } else {
        set i_ges_ [expr $i_ges_+$i]
        incr i_anz_
        #write(*,*) i_anz_,i_ges,fx
    }

    return $ierr
}
###################################################################################
# Unterprogramm zum Ermitteln des Winkel zwischen den beiden Geraden
# Doppelpunkt-Momentanpol 1 und Doppelpunkt-Momentanpol 2

proc ywert8_rf2 {x eps fxs_ ierr_ \
                 weg_a_ lges_a x1_ ax1_ bx1_ cx1_ dx1_ y1_ ay1_ by1_ cy1_ dy1_ \
                 x2_ ax2_ bx2_ cx2_ dx2_ y2_ ay2_ by2_ cy2_ dy2_} {

    upvar $fxs_ fxs
    upvar $ierr_ ierr

    upvar $weg_a_ weg_a
    upvar $x1_ x1
    upvar $ax1_ ax1
    upvar $bx1_ bx1
    upvar $cx1_ cx1
    upvar $dx1_ dx1
    upvar $y1_ y1
    upvar $ay1_ ay1
    upvar $by1_ by1
    upvar $cy1_ cy1
    upvar $dy1_ dy1
    upvar $x2_ x2
    upvar $ax2_ ax2
    upvar $bx2_ bx2
    upvar $cx2_ cx2
    upvar $dx2_ dx2
    upvar $y2_ y2
    upvar $ay2_ ay2
    upvar $by2_ by2
    upvar $cy2_ cy2
    upvar $dy2_ dy2

# geg.: x,eps,jberech_abl
# ges.: ywert8_rf2,ierr

# x       : x-Wert fr f(x)
# eps     : Grenzwert: Zahlen, die kleiner als diese Zahl sind, werden,
#                    wenn sie im Nenner stehen, als 0 angesehen
# jberech_abl: Kennzahl
#         iberech_abl=0 --> Ableitung fr Newton  wird nicht berechnet
#                           ('****ss' mu nicht gegeben sein!)
#         iberech_abl=1 --> Ableitung fr Newton  wird berechnet
# ywert8_rf2: f(x)
# fxs:      Ableitung von ywert8_rf2
# ierr    : Kennzahl
#           ierr=0 --> Eine Lsung wurde gefunden
#           ierr=1 --> Es trat ein Fehler auf
#.................................................................
#.................................................................
    global x1p1 y1p1 x1p2 y1p2
    global x1p1s y1p1s x1p2s y1p2s
    global x1p1ss y1p1ss x1p2ss y1p2ss

    if {[info exists i_spl] == 0} then {
        set i_spl 1
    }

    set ierr [spline_a2_interp $x $lges_a weg_a ax1 bx1 cx1 dx1 i_spl x2p1 x2p1s x2p1ss]
    if {$ierr == 0} then {
        set ierr [spline_a2_interp $x $lges_a weg_a \
            ay1 by1 cy1 dy1 i_spl y2p1 y2p1s y2p1ss]
    }
    if {$ierr == 0} then {
        set ierr [spline_a2_interp $x $lges_a weg_a \
            ax2 bx2 cx2 dx2 i_spl x2p2 x2p2s x2p2ss]
    }
    if {$ierr == 0} then {
        set ierr [spline_a2_interp $x $lges_a weg_a \
            ay2 by2 cy2 dy2 i_spl y2p2 y2p2s y2p2ss]
    }

    if {$ierr == 0} then {
        puts ok8
        set ierr [kue8_punkt x1p1 y1p1 x1p1s y1p1s x1p1ss y1p1ss \
            x2p1 y2p1 x2p1s y2p1s x2p1ss y2p1ss \
            x1p2 y1p2 x1p2s y1p2s x1p2ss y1p2ss \
            x2p2 y2p2 x2p2s y2p2s x2p2ss y2p2ss \
            $eps  ywert8_rf2 fxs xdp ydp xg1 yg1 xg2 yg2]
        puts ok9
        if {$ierr == 0} then {
            call kue8_punkt(y1p1 x1p1 y1p1s x1p1s y1p1ss x1p1ss \
                y2p1 x2p1 y2p1s x2p1s y2p1ss x2p1ss \
                y1p2 x1p2 y1p2s x1p2s y1p2ss x1p2ss \
                y2p2 x2p2 y2p2s x2p2s y2p2ss x2p2ss \
                $eps  ywert8_rf2 fxs ydp xdp yg1 xg1 yg2 xg2)
        }
    } else {
        set ierr -1
    }
    if {$ierr != 0} then {
        tk_messageBox -type ok -message "ywert8_rf2: ierr=$ierr"
    }

    return $ywert8_rf2
}
######################################################################################
# Setzen der Lage 1 zum ermitteln eines Doppelpunktes

proc setz_lage1 {weg_1 i_spl \
      weg_a_ x1_ ax1_ bx1_ cx1_ dx1_ y1_ ay1_ by1_ cy1_ dy1_ \
             x2_ ax2_ bx2_ cx2_ dx2_ y2_ ay2_ by2_ cy2_ dy2_ lges_a} {

# geg.: weg_1,i_spl
# ges.: ierr

# weg_1:        Weg fr Lage 1
# i_spl:        Startwert fr Suche der Sttzstelle von Lage 1
# ierr:         Kennzahl
#               ierr=0 --> Es trat kein Fehler beim interprtieren der
#                          Splines auf
#               ierr<>1 --> Es trat ein Fehler auf
#..................................................................
#..................................................................
    upvar $weg_a_ weg_a
    upvar $x1_ x1
    upvar $ax1_ ax1
    upvar $bx1_ bx1
    upvar $cx1_ cx1
    upvar $dx1_ dx1
    upvar $y1_ y1
    upvar $ay1_ ay1
    upvar $by1_ by1
    upvar $cy1_ cy1
    upvar $dy1_ dy1
    upvar $x2_ x2
    upvar $ax2_ ax2
    upvar $bx2_ bx2
    upvar $cx2_ cx2
    upvar $dx2_ dx2
    upvar $y2_ y2
    upvar $ay2_ ay2
    upvar $by2_ by2
    upvar $cy2_ cy2
    upvar $dy2_ dy2

    global x1p1 y1p1 x1p2 y1p2
    global x1p1s y1p1s x1p2s y1p2s
    global x1p1ss y1p1ss x1p2ss y1p2ss

    set ierr [spline_a2_interp $weg_1 $lges_a weg_a ax1 bx1 cx1 dx1 i_spl x1p1 x1p1s x1p1ss]
    if {$ierr == 0} then {
        set ierr [spline_a2_interp $weg_1 $lges_a weg_a \
                         ay1 by1 cy1 dy1 i_spl y1p1 y1p1s y1p1ss]
    }
    if {$ierr == 0} then {
        set ierr [spline_a2_interp $weg_1 $lges_a weg_a \
                         ax2 bx2 cx2 dx2 i_spl x1p2 x1p2s x1p2ss]
    }
    if {$ierr == 0} then {
        set ierr [spline_a2_interp $weg_1 $lges_a weg_a \
                         ay2 by2 cy2 dy2 i_spl y1p2 y1p2s y1p2ss]
    }

    return $ierr
}
##############################################################################
#c Unterprogramm zum Ermitteln des Weges (der Lnge) einer Kurve,
#c wobei die Stcke zwischen den Sttzstellen als Geraden angenommen
#c werden

proc erm_weg {lges x_ y_ weg_} {

    upvar $x_ x
    upvar $y_ y
    upvar $weg_ weg

#c geg.: lges,x,y

#c lges  : Anzahl der Stuetzstellen der Kurve
#c x()   : x-Koordinaten der Kurve
#c y()   : y-Koordinaten der Kurve
#c weg() : Weg der Kurve zwischen Anfangssttzstelle und der betreffenden
#c         Sttzstelle
#c....................................................................
#c....................................................................
        set weg(1) 0
#        do i=2,lges
        for {set i 2} {$i <= $lges} {incr i} {
            set dx [expr $x($i)-$x([expr $i-1]) ]
            set dy [expr $y($i)-$y([expr $i-1]) ]
            set weg($i) [expr $weg([expr $i-1])+sqrt([expr $dx*$dx+$dy*$dy]) ]
        }
}
###########################################################################
# Momentanpole

proc kue8_punkt {x1p1_ y1p1_ x1p1s_ y1p1s_ x1p1ss_ y1p1ss_ \
                 x2p1_ y2p1_ x2p1s_ y2p1s_ x2p1ss_ y2p1ss_ \
                 x1p2_ y1p2_ x1p2s_ y1p2s_ x1p2ss_ y1p2ss_ \
                 x2p2_ y2p2_ x2p2s_ y2p2s_ x2p2ss_ y2p2ss_ \
                 eps fx_ fxs_ xdp_ ydp_ xg1_ yg1_ xg2_ yg2_} {

        puts "eps=$eps"


    return $ierr
}
##############################################################################
global lgesOhneParallelLage

set is1 10
set is2 [expr $lgesOhneParallelLage/2 -10]
set ivorz 1
kue xk1_df yk1_df xk2_df yk2_df $lgesOhneParallelLage $is1 $is2 $ivorz
